﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private timer1 As Timer
End Sub

Public Sub Initialize
	timer1.Initialize("timer1", 10 * DateTime.TicksPerMinute) 'check for new libraries every 10 minutes
	timer1.Enabled = True
	Timer1_Tick
	StartMessageLoop	
End Sub

Private Sub Timer1_Tick
	For Each product In Main.LibrariesPath.Keys
		Try
			IndexFolder(Main.LibrariesPath.Get(product), product)
		Catch
			Log(LastException)
		End Try
	Next
End Sub

Private Sub IndexFolder (Path As String, Product As String)
	Dim versions As Map
	If Main.esclient.Exists("meta", "dates", Product) Then
		versions = Main.esclient.Get("meta", "dates", Product)
		Log($"Current indexed libraries (${Product})"$)
		For Each lib As String In versions.Keys
			Log($"${lib}: $DateTime{versions.Get(lib)}"$)
		Next
	Else
		versions.Initialize
	End If
	For Each f As String In File.ListFiles(Path)
		If f.EndsWith(".xml") Then
			Dim libraryName As String = f.SubString2(0, f.Length - 4) 'remove extension
			Dim currentDate As Long = versions.GetDefault(libraryName, 0)
			Dim NewDate As Long = File.LastModified(Path, f)
			If currentDate < NewDate Then
				IndexLibrary(libraryName, Path, Product)
				versions.Put(libraryName, NewDate)
			End If
		End If
	Next
	Main.esclient.Insert("meta", "dates", Product, versions)
End Sub

Private Sub IndexLibrary (Library As String, Path As String, Product As String)
	Log("Indexing library: " & Library)
	Dim s As String = File.ReadString(Path, Library & ".xml")
	Dim LibraryDocument As Map = CreateMap("product": Product, "text": s)
	Main.esclient.Insert("main", "library", Library, LibraryDocument)
End Sub