﻿Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Handler class
Sub Class_Globals
	
End Sub

Public Sub Initialize
	
End Sub

Sub Handle(req As ServletRequest, resp As ServletResponse)
	Dim QueryString As String = req.GetParameter("query")
	If QueryString = "" Then
		resp.SendError(500, "Missing query.")
		Return
	End If
	resp.ContentType = "text/html"
	Dim Query As Map = CreateMap("simple_query_string": _
		CreateMap( _
			"fields": Array("text"), _
			"query": QueryString))
	
	Dim Highlighter As Map = CreateMap( _
		"pre_tags": Array("<b>"), "post_tags": Array("</b>"), _
		"fields": CreateMap("text": CreateMap()))
	'count the number of total results grouped by product.
	'https://www.elastic.co/guide/en/elasticsearch/reference/current/search-aggregations-bucket-terms-aggregation.html
	'(we need to use product.keyword instead of product because we are using the default mapping)
	Dim aggs As Map = CreateMap("products": CreateMap("terms": CreateMap("field": "product.keyword")))
	Dim esres As ESResponse = Main.esclient.Search("main", "library", _
		CreateMap("query": Query, _
		 "highlight": Highlighter, _
		 "aggs": aggs, _
		 "_source": Array("product")))
	If esres.Hits.Size = 0 Then
		resp.Write("No match found!")
	Else
		Dim sb As StringBuilder
		sb.Initialize
		'get the aggregation result
		Dim m As Map = esres.ResponseAsMap.Get("aggregations")
		m = m.Get("products")
		Dim buckets As List = m.Get("buckets")
		sb.Append("Total results per product: ")
		For Each productCount As Map In buckets
			sb.Append(productCount.Get("key")).Append(": ").Append(productCount.Get("doc_count")).Append(" ")
		Next
		sb.Append("<hr/>")
		'get the hits
		For Each searchResult As Map In esres.Hits
			Dim highlightMap As Map = searchResult.Get("highlight")
			Dim highlights As List = highlightMap.Get("text")
			Dim id As String = searchResult.Get("_id")
			Dim source As Map = searchResult.Get("_source")
			Dim product As String = source.Get("product")
			sb.Append("<h2>").Append(id).Append($" (${product})"$).Append("</h2>")
			For Each h As String In highlights
				sb.Append(h).Append("<br/>")
			Next
			sb.Append("<hr/>")
		Next
		resp.Write(sb.ToString)
	End If
End Sub